library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity bin2bcd_tb is
--  Port ( );
end bin2bcd_tb;

architecture Behavioral of bin2bcd_tb is
    constant C_CLK_PERIOD: time := 8 ns;
    
    component  bin2bcd is
        port ( 
            clk : in std_logic;
            reset : in std_logic;
            bin_in : in std_logic_vector(7 downto 0);
            bcd_out : out std_logic_vector(11 downto 0)
        );
    end component;
    
    signal clk : std_logic := '1';
    signal reset : std_logic;
    signal bin_in : std_logic_vector(7 downto 0);
    signal bcd_out : std_logic_vector(11 downto 0);
begin
    DUT : bin2bcd 
        port map (
            clk => clk,
            reset => reset,
            bin_in => bin_in,
            bcd_out => bcd_out
        );
    
    clk <= not clk after C_CLK_PERIOD/2;
    
    STIMULUS: process is
    begin
        reset <= '1';
        bin_in <= x"56";
        wait for C_CLK_PERIOD*3.2;
        reset <= '0';
        wait for C_CLK_PERIOD*20;
        bin_in <= x"05";
        wait for C_CLK_PERIOD*20;
        bin_in <= x"ff";
        wait for C_CLK_PERIOD*20;
        wait;
    end process STIMULUS;

end Behavioral;
